# coding: utf-8

"""
    Positions

    API to retrieve and monitor managed positions for Start of Day Positions. Managed positions are positions enriched with additional context such as restrictions and substitutions.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from asdk_plugin_portfolio_management.agraph.portfolio_management.positions.positions.v2.PositionsAPI.models.v1_single_data_filter import V1SingleDataFilter

class V1DataFilter(BaseModel):
    """
    V1DataFilter
    """
    single_data_filter: Optional[V1SingleDataFilter] = Field(None, alias="singleDataFilter")
    data_filter_tree: Optional[V1DataFilterTree] = Field(None, alias="dataFilterTree")
    __properties = ["singleDataFilter", "dataFilterTree"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1DataFilter:
        """Create an instance of V1DataFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of single_data_filter
        if self.single_data_filter:
            _dict['singleDataFilter'] = self.single_data_filter.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data_filter_tree
        if self.data_filter_tree:
            _dict['dataFilterTree'] = self.data_filter_tree.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1DataFilter:
        """Create an instance of V1DataFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1DataFilter.parse_obj(obj)

        _obj = V1DataFilter.parse_obj({
            "single_data_filter": V1SingleDataFilter.from_dict(obj.get("singleDataFilter")) if obj.get("singleDataFilter") is not None else None,
            "data_filter_tree": V1DataFilterTree.from_dict(obj.get("dataFilterTree")) if obj.get("dataFilterTree") is not None else None
        })
        return _obj

