# coding: utf-8

"""
    Positions

    API to retrieve and monitor managed positions for Start of Day Positions. Managed positions are positions enriched with additional context such as restrictions and substitutions.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictInt

class V1RelativeDate(BaseModel):
    """
    V1RelativeDate
    """
    calendar_date: Optional[date] = Field(None, alias="calendarDate")
    relative_days: Optional[StrictInt] = Field(None, alias="relativeDays")
    __properties = ["calendarDate", "relativeDays"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1RelativeDate:
        """Create an instance of V1RelativeDate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1RelativeDate:
        """Create an instance of V1RelativeDate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1RelativeDate.parse_obj(obj)

        _obj = V1RelativeDate.parse_obj({
            "calendar_date": obj.get("calendarDate"),
            "relative_days": obj.get("relativeDays")
        })
        return _obj

