# coding: utf-8

"""
    Positions

    API to retrieve and monitor managed positions for Start of Day Positions. Managed positions are positions enriched with additional context such as restrictions and substitutions.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_portfolio_management.agraph.portfolio_management.positions.positions.v2.PositionsAPI.models.v2_credit_type import V2CreditType
from asdk_plugin_portfolio_management.agraph.portfolio_management.positions.positions.v2.PositionsAPI.models.v2_issuer_attribute import V2IssuerAttribute

class V2CreditViewSetting(BaseModel):
    """
    Credit enhancement data view settings. This is to apply specialized logic for issuer filter for which data filter cannot be used.
    """
    credit_type: Optional[V2CreditType] = Field(None, alias="creditType")
    issuer_attribute: Optional[V2IssuerAttribute] = Field(None, alias="issuerAttribute")
    issuer_values: Optional[conlist(StrictStr)] = Field(None, alias="issuerValues")
    __properties = ["creditType", "issuerAttribute", "issuerValues"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V2CreditViewSetting:
        """Create an instance of V2CreditViewSetting from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V2CreditViewSetting:
        """Create an instance of V2CreditViewSetting from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V2CreditViewSetting.parse_obj(obj)

        _obj = V2CreditViewSetting.parse_obj({
            "credit_type": obj.get("creditType"),
            "issuer_attribute": obj.get("issuerAttribute"),
            "issuer_values": obj.get("issuerValues")
        })
        return _obj

