# coding: utf-8

"""
    Positions

    API to retrieve and monitor managed positions for Start of Day Positions. Managed positions are positions enriched with additional context such as restrictions and substitutions.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_portfolio_management.agraph.portfolio_management.positions.positions.v2.PositionsAPI.models.v2_position_warning import V2PositionWarning

class V2PortfolioPositionWarnings(BaseModel):
    """
    V2PortfolioPositionWarnings
    """
    portfolio_name: Optional[StrictStr] = Field(None, alias="portfolioName")
    positions_warnings: Optional[conlist(V2PositionWarning)] = Field(None, alias="positionsWarnings")
    __properties = ["portfolioName", "positionsWarnings"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V2PortfolioPositionWarnings:
        """Create an instance of V2PortfolioPositionWarnings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in positions_warnings (list)
        _items = []
        if self.positions_warnings:
            for _item in self.positions_warnings:
                if _item:
                    _items.append(_item.to_dict())
            _dict['positionsWarnings'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V2PortfolioPositionWarnings:
        """Create an instance of V2PortfolioPositionWarnings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V2PortfolioPositionWarnings.parse_obj(obj)

        _obj = V2PortfolioPositionWarnings.parse_obj({
            "portfolio_name": obj.get("portfolioName"),
            "positions_warnings": [V2PositionWarning.from_dict(_item) for _item in obj.get("positionsWarnings")] if obj.get("positionsWarnings") is not None else None
        })
        return _obj

