# coding: utf-8

"""
    Custom Investment Dataset Reader

    API for reading Dataset Definitions and Entities.  _CIDS does not transform the input data in any kind. The writer of the data owns it and is responsible for this data. CIDS provides a way to ingest the custom investment data into Aladdin for usage across Portfolio Management tools._  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class V1DatasetType(str, Enum):
    """
    Describes the type of Entities can be added to this Dataset.  This is only applicable for leaf level Dataset and not applicable for Category, Class and Group.   - DATASET_TYPE_UNSPECIFIED: Unspecified TYPE. This type of Dataset can store plain string data in its entities.  - DATASET_TYPE_KEY_VALUE: KEY_VALUE TYPE. This type of Dataset can store key-value data in its entites.  - DATASET_TYPE_SCHEMA: SCHEMA TYPE. This type of Dataset can store multi-attributes data.  - DATASET_TYPE_JSON: JSON TYPE. This type of Dataset can store JSON data in its entities.
    """

    """
    allowed enum values
    """
    DATASET_TYPE_UNSPECIFIED = 'DATASET_TYPE_UNSPECIFIED'
    DATASET_TYPE_KEY_VALUE = 'DATASET_TYPE_KEY_VALUE'
    DATASET_TYPE_SCHEMA = 'DATASET_TYPE_SCHEMA'
    DATASET_TYPE_JSON = 'DATASET_TYPE_JSON'

    @classmethod
    def from_json(cls, json_str: str) -> V1DatasetType:
        """Create an instance of V1DatasetType from a JSON string"""
        return V1DatasetType(json.loads(json_str))


