# coding: utf-8

"""
    Custom Investment Dataset Reader

    API for reading Dataset Definitions and Entities.  _CIDS does not transform the input data in any kind. The writer of the data owns it and is responsible for this data. CIDS provides a way to ingest the custom investment data into Aladdin for usage across Portfolio Management tools._  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_portfolio_management.agraph.portfolio_management.setup.cids.v1.CIDReaderAPI.models.v1_cid_dataset_definition import V1CIDDatasetDefinition

class V1ListCIDDatasetDefinitionsResponse(BaseModel):
    """
    V1ListCIDDatasetDefinitionsResponse
    """
    dataset_definitions: Optional[conlist(V1CIDDatasetDefinition)] = Field(None, alias="datasetDefinitions", description="List of retrieved Dataset Definitions.")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="Pagination is not implemented yet.  A token, which can be sent as 'page_token' to retrieve the next page. If this field is omitted, there are no subsequent pages.")
    __properties = ["datasetDefinitions", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ListCIDDatasetDefinitionsResponse:
        """Create an instance of V1ListCIDDatasetDefinitionsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in dataset_definitions (list)
        _items = []
        if self.dataset_definitions:
            for _item in self.dataset_definitions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['datasetDefinitions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ListCIDDatasetDefinitionsResponse:
        """Create an instance of V1ListCIDDatasetDefinitionsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ListCIDDatasetDefinitionsResponse.parse_obj(obj)

        _obj = V1ListCIDDatasetDefinitionsResponse.parse_obj({
            "dataset_definitions": [V1CIDDatasetDefinition.from_dict(_item) for _item in obj.get("datasetDefinitions")] if obj.get("datasetDefinitions") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

