# coding: utf-8

"""
    Custom Investment Dataset Writer

    API for writing Dataset Definitions and Entities.  _CIDS does not transform the input data in any kind. The writer of the data owns it and is responsible for this data. CIDS provides a way to ingest the custom investment data into Aladdin for usage across Portfolio Management tools._  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from asdk_plugin_portfolio_management.agraph.portfolio_management.setup.cids.v1.CIDWriterAPI.models.rpc_status import RpcStatus
from asdk_plugin_portfolio_management.agraph.portfolio_management.setup.cids.v1.CIDWriterAPI.models.v1_expire_cid_entity_response import V1ExpireCIDEntityResponse

class V1BatchExpireCIDEntitiesResponse(BaseModel):
    """
    V1BatchExpireCIDEntitiesResponse
    """
    status: Optional[RpcStatus] = None
    entities: Optional[conlist(V1ExpireCIDEntityResponse)] = Field(None, description="Entities expired or failed with status each.")
    __properties = ["status", "entities"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1BatchExpireCIDEntitiesResponse:
        """Create an instance of V1BatchExpireCIDEntitiesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in entities (list)
        _items = []
        if self.entities:
            for _item in self.entities:
                if _item:
                    _items.append(_item.to_dict())
            _dict['entities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1BatchExpireCIDEntitiesResponse:
        """Create an instance of V1BatchExpireCIDEntitiesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1BatchExpireCIDEntitiesResponse.parse_obj(obj)

        _obj = V1BatchExpireCIDEntitiesResponse.parse_obj({
            "status": RpcStatus.from_dict(obj.get("status")) if obj.get("status") is not None else None,
            "entities": [V1ExpireCIDEntityResponse.from_dict(_item) for _item in obj.get("entities")] if obj.get("entities") is not None else None
        })
        return _obj

