# coding: utf-8

"""
    Custom Investment Dataset Writer

    API for writing Dataset Definitions and Entities.  _CIDS does not transform the input data in any kind. The writer of the data owns it and is responsible for this data. CIDS provides a way to ingest the custom investment data into Aladdin for usage across Portfolio Management tools._  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictStr, conbytes, constr, validator

class V1UploadEntitiesFileRequest(BaseModel):
    """
    V1UploadEntitiesFileRequest
    """
    content: Union[conbytes(strict=True), constr(strict=True)] = Field(...)
    filename: StrictStr = Field(...)
    dataset: StrictStr = Field(...)
    email: StrictStr = Field(...)
    __properties = ["content", "filename", "dataset", "email"]

    @validator('content')
    def content_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$", value):
            raise ValueError(r"must validate the regular expression /^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1UploadEntitiesFileRequest:
        """Create an instance of V1UploadEntitiesFileRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1UploadEntitiesFileRequest:
        """Create an instance of V1UploadEntitiesFileRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1UploadEntitiesFileRequest.parse_obj(obj)

        _obj = V1UploadEntitiesFileRequest.parse_obj({
            "content": obj.get("content"),
            "filename": obj.get("filename"),
            "dataset": obj.get("dataset"),
            "email": obj.get("email")
        })
        return _obj

