# coding: utf-8

"""
    Aladdin Investment Target

    This service provides advance capabilities to create and manage all types of Aladdin Investment Targets and their associated subscriptions.  # noqa: E501

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_portfolio_management.agraph.portfolio_management.target.investment_target.v1.InvestmentTargetAPI.models.v1_target_subscription import V1TargetSubscription

class V1BatchUpdateInvestmentTargetSubscriptionsRequest(BaseModel):
    """
    V1BatchUpdateInvestmentTargetSubscriptionsRequest
    """
    target_subscriptions: conlist(V1TargetSubscription) = Field(..., alias="targetSubscriptions", description="target subscriptions to update.")
    update_mask: Optional[StrictStr] = Field(None, alias="updateMask", description="List of fields to be updated.")
    __properties = ["targetSubscriptions", "updateMask"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1BatchUpdateInvestmentTargetSubscriptionsRequest:
        """Create an instance of V1BatchUpdateInvestmentTargetSubscriptionsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in target_subscriptions (list)
        _items = []
        if self.target_subscriptions:
            for _item in self.target_subscriptions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['targetSubscriptions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1BatchUpdateInvestmentTargetSubscriptionsRequest:
        """Create an instance of V1BatchUpdateInvestmentTargetSubscriptionsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1BatchUpdateInvestmentTargetSubscriptionsRequest.parse_obj(obj)

        _obj = V1BatchUpdateInvestmentTargetSubscriptionsRequest.parse_obj({
            "target_subscriptions": [V1TargetSubscription.from_dict(_item) for _item in obj.get("targetSubscriptions")] if obj.get("targetSubscriptions") is not None else None,
            "update_mask": obj.get("updateMask")
        })
        return _obj

