# coding: utf-8

"""
    Aladdin Investment Target

    This service provides advance capabilities to create and manage all types of Aladdin Investment Targets and their associated subscriptions.  # noqa: E501

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from asdk_plugin_portfolio_management.agraph.portfolio_management.target.investment_target.v1.InvestmentTargetAPI.models.rpc_status import RpcStatus
from asdk_plugin_portfolio_management.agraph.portfolio_management.target.investment_target.v1.InvestmentTargetAPI.models.v1_target_metadata import V1TargetMetadata

class V1FilterInvestmentTargetMetadataResponse(BaseModel):
    """
    V1FilterInvestmentTargetMetadataResponse
    """
    target_metadata_response: Optional[V1TargetMetadata] = Field(None, alias="targetMetadataResponse")
    entity_response_status: Optional[RpcStatus] = Field(None, alias="entityResponseStatus")
    __properties = ["targetMetadataResponse", "entityResponseStatus"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterInvestmentTargetMetadataResponse:
        """Create an instance of V1FilterInvestmentTargetMetadataResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of target_metadata_response
        if self.target_metadata_response:
            _dict['targetMetadataResponse'] = self.target_metadata_response.to_dict()
        # override the default output from pydantic by calling `to_dict()` of entity_response_status
        if self.entity_response_status:
            _dict['entityResponseStatus'] = self.entity_response_status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterInvestmentTargetMetadataResponse:
        """Create an instance of V1FilterInvestmentTargetMetadataResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterInvestmentTargetMetadataResponse.parse_obj(obj)

        _obj = V1FilterInvestmentTargetMetadataResponse.parse_obj({
            "target_metadata_response": V1TargetMetadata.from_dict(obj.get("targetMetadataResponse")) if obj.get("targetMetadataResponse") is not None else None,
            "entity_response_status": RpcStatus.from_dict(obj.get("entityResponseStatus")) if obj.get("entityResponseStatus") is not None else None
        })
        return _obj

