# coding: utf-8

"""
    Aladdin Investment Target

    This service provides advance capabilities to create and manage all types of Aladdin Investment Targets and their associated subscriptions.  # noqa: E501

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class V1TargetFX(BaseModel):
    """
    V1TargetFX
    """
    fx_term: Optional[StrictStr] = Field(None, alias="fxTerm")
    currency_pair: StrictStr = Field(..., alias="currencyPair")
    currency_swap: Optional[StrictBool] = Field(None, alias="currencySwap")
    expiry_date: Optional[date] = Field(None, alias="expiryDate")
    __properties = ["fxTerm", "currencyPair", "currencySwap", "expiryDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1TargetFX:
        """Create an instance of V1TargetFX from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1TargetFX:
        """Create an instance of V1TargetFX from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1TargetFX.parse_obj(obj)

        _obj = V1TargetFX.parse_obj({
            "fx_term": obj.get("fxTerm"),
            "currency_pair": obj.get("currencyPair"),
            "currency_swap": obj.get("currencySwap"),
            "expiry_date": obj.get("expiryDate")
        })
        return _obj

