# coding: utf-8

"""
    Aladdin Investment Target

    This service provides advance capabilities to create and manage all types of Aladdin Investment Targets and their associated subscriptions.  # noqa: E501

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from asdk_plugin_portfolio_management.agraph.portfolio_management.target.investment_target.v1.InvestmentTargetAPI.models.v1_options_style import V1OptionsStyle
from asdk_plugin_portfolio_management.agraph.portfolio_management.target.investment_target.v1.InvestmentTargetAPI.models.v1_put_call_type import V1PutCallType

class V1TargetFXOptions(BaseModel):
    """
    V1TargetFXOptions
    """
    expiry_date: date = Field(..., alias="expiryDate")
    currency_pair: StrictStr = Field(..., alias="currencyPair")
    options_style: Optional[V1OptionsStyle] = Field(None, alias="optionsStyle")
    put_call_type: Optional[V1PutCallType] = Field(None, alias="putCallType")
    strike: Union[StrictFloat, StrictInt] = Field(...)
    __properties = ["expiryDate", "currencyPair", "optionsStyle", "putCallType", "strike"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1TargetFXOptions:
        """Create an instance of V1TargetFXOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1TargetFXOptions:
        """Create an instance of V1TargetFXOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1TargetFXOptions.parse_obj(obj)

        _obj = V1TargetFXOptions.parse_obj({
            "expiry_date": obj.get("expiryDate"),
            "currency_pair": obj.get("currencyPair"),
            "options_style": obj.get("optionsStyle"),
            "put_call_type": obj.get("putCallType"),
            "strike": obj.get("strike")
        })
        return _obj

