# coding: utf-8

"""
    Aladdin Strategy

    Contains operations for creating, updating, and retrieving trade strategies in Aladdin.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class V1FilterStrategiesByPatternQuery(BaseModel):
    """
    V1FilterStrategiesByPatternQuery
    """
    strategy_name_pattern: StrictStr = Field(..., alias="strategyNamePattern", description="Represents strategy name pattern. Name pattern here uses \"*\" to allow matching for that pattern anywhere within the strategy name.")
    expire_date: Optional[date] = Field(None, alias="expireDate", description="Represents expire date. If provided, strategies with expire date greater than or  equal to given date will be returned.")
    include_expired: Optional[StrictBool] = Field(None, alias="includeExpired")
    __properties = ["strategyNamePattern", "expireDate", "includeExpired"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterStrategiesByPatternQuery:
        """Create an instance of V1FilterStrategiesByPatternQuery from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterStrategiesByPatternQuery:
        """Create an instance of V1FilterStrategiesByPatternQuery from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterStrategiesByPatternQuery.parse_obj(obj)

        _obj = V1FilterStrategiesByPatternQuery.parse_obj({
            "strategy_name_pattern": obj.get("strategyNamePattern"),
            "expire_date": obj.get("expireDate"),
            "include_expired": obj.get("includeExpired")
        })
        return _obj

